"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const aksel_icons_1 = require("@navikt/aksel-icons");
const Theme_1 = require("../theme/Theme");
const typography_1 = require("../typography");
const composeEventHandlers_1 = require("../util/composeEventHandlers");
const AccordionContext_1 = require("./AccordionContext");
const AccordionItem_1 = require("./AccordionItem");
const AccordionHeader = (0, react_1.forwardRef)((_a, ref) => {
    var _b;
    var { children, className, onClick } = _a, rest = __rest(_a, ["children", "className", "onClick"]);
    const itemContext = (0, react_1.useContext)(AccordionItem_1.AccordionItemContext);
    const accordionContext = (0, react_1.useContext)(AccordionContext_1.AccordionContext);
    const themeContext = (0, Theme_1.useThemeInternal)(false);
    const { cn } = (0, Theme_1.useRenameCSS)();
    if (itemContext === null) {
        console.error("<Accordion.Header> has to be used within an <Accordion.Item>, which in turn must be within an <Accordion>");
        return null;
    }
    let headingSize = (_b = accordionContext === null || accordionContext === void 0 ? void 0 : accordionContext.headingSize) !== null && _b !== void 0 ? _b : "small";
    if (themeContext) {
        /* Fallback to "medium" Accordion-size if any other sizes are used */
        headingSize = (accordionContext === null || accordionContext === void 0 ? void 0 : accordionContext.size) === "small" ? "xsmall" : "small";
    }
    return (react_1.default.createElement("button", Object.assign({ ref: ref }, rest, { className: cn("navds-accordion__header", className), onClick: (0, composeEventHandlers_1.composeEventHandlers)(onClick, itemContext.toggleOpen), "aria-expanded": itemContext.open, type: "button" }),
        react_1.default.createElement("span", { className: cn("navds-accordion__icon-wrapper") },
            react_1.default.createElement(aksel_icons_1.ChevronDownIcon, { className: cn("navds-accordion__header-chevron"), "aria-hidden": true })),
        react_1.default.createElement(typography_1.Heading, { size: headingSize, as: "span", className: cn("navds-accordion__header-content") }, children)));
});
exports.default = AccordionHeader;
//# sourceMappingURL=AccordionHeader.js.map