"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AccordionItemContext = void 0;
const react_1 = __importStar(require("react"));
const Theme_1 = require("../theme/Theme");
const util_1 = require("../util");
const useControllableState_1 = require("../util/hooks/useControllableState");
const AccordionContext_1 = require("./AccordionContext");
exports.AccordionItemContext = (0, react_1.createContext)(null);
const AccordionItem = (0, react_1.forwardRef)((_a, ref) => {
    var { children, className, open, defaultOpen = false, onOpenChange } = _a, rest = __rest(_a, ["children", "className", "open", "defaultOpen", "onOpenChange"]);
    const [_open, _setOpen] = (0, useControllableState_1.useControllableState)({
        defaultValue: defaultOpen,
        value: open,
        onChange: onOpenChange,
    });
    const context = (0, react_1.useContext)(AccordionContext_1.AccordionContext);
    const { cn } = (0, Theme_1.useRenameCSS)();
    const shouldAnimate = (0, react_1.useRef)(!(Boolean(open) || defaultOpen));
    const handleOpen = () => {
        _setOpen((x) => !x);
        shouldAnimate.current = true;
    };
    if (!(context === null || context === void 0 ? void 0 : context.mounted)) {
        console.error("<Accordion.Item> has to be used within an <Accordion>");
    }
    return (react_1.default.createElement("div", Object.assign({ className: cn("navds-accordion__item", className, {
            "navds-accordion__item--open": _open,
            "navds-accordion__item--neutral": (context === null || context === void 0 ? void 0 : context.variant) === "neutral",
            "navds-accordion__item--no-animation": !shouldAnimate.current,
        }), "data-expanded": _open, ref: ref }, (0, util_1.omit)(rest, ["onClick"])),
        react_1.default.createElement(exports.AccordionItemContext.Provider, { value: {
                open: _open,
                toggleOpen: handleOpen,
            } }, children)));
});
exports.default = AccordionItem;
//# sourceMappingURL=AccordionItem.js.map