import React, { HTMLAttributes } from "react";
import { HeadingProps } from "../typography";
export interface ChatBubbleProps extends HTMLAttributes<HTMLDivElement> {
    /**
     * Bubble text.
     */
    children: React.ReactNode;
    /**
     * Name/sender on bubble.
     */
    name?: string;
    /**
     * Timestamp for sent message.
     */
    timestamp?: string;
    /**
     * Overrides hoizontal position of toptext.
     */
    toptextPosition?: "left" | "right";
    /**
     * The heading level for the toptext.
     * @default "3"
     */
    toptextHeadingLevel?: Exclude<HeadingProps["level"], "1">;
}
declare const Bubble: React.ForwardRefExoticComponent<ChatBubbleProps & React.RefAttributes<HTMLDivElement>>;
export default Bubble;
