"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RemovableChips = void 0;
const react_1 = __importStar(require("react"));
const aksel_icons_1 = require("@navikt/aksel-icons");
const Theme_1 = require("../theme/Theme");
const composeEventHandlers_1 = require("../util/composeEventHandlers");
const i18n_hooks_1 = require("../util/i18n/i18n.hooks");
exports.RemovableChips = (0, react_1.forwardRef)((_a, ref) => {
    var { children, variant, onDelete, className, onClick, type = "button", "data-color": color } = _a, rest = __rest(_a, ["children", "variant", "onDelete", "className", "onClick", "type", "data-color"]);
    const translate = (0, i18n_hooks_1.useI18n)("Chips");
    const themeContext = (0, Theme_1.useThemeInternal)(false);
    const { cn } = (0, Theme_1.useRenameCSS)();
    let localVariant;
    if (themeContext) {
        localVariant = variant;
    }
    else {
        localVariant = variant !== null && variant !== void 0 ? variant : "action";
    }
    return (react_1.default.createElement("button", Object.assign({ "data-color": color !== null && color !== void 0 ? color : variantToColor(localVariant) }, rest, { ref: ref, type: type, className: cn("navds-chips__chip navds-chips__removable navds-chips--icon-right", className, {
            [`navds-chips__removable--${localVariant}`]: localVariant,
        }), "aria-label": `${children} ${translate("Removable.labelSuffix")}`, onClick: (0, composeEventHandlers_1.composeEventHandlers)(onClick, onDelete) }),
        react_1.default.createElement("span", { className: cn("navds-chips__chip-text") }, children),
        react_1.default.createElement("span", { className: cn("navds-chips__removable-icon") },
            react_1.default.createElement(aksel_icons_1.XMarkIcon, { "aria-hidden": true }))));
});
function variantToColor(variant) {
    switch (variant) {
        case "action":
            return "accent";
        case "neutral":
            return "neutral";
        default:
            return undefined;
    }
}
exports.default = exports.RemovableChips;
//# sourceMappingURL=Removable.js.map