"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CopyButton = void 0;
const react_1 = __importStar(require("react"));
const aksel_icons_1 = require("@navikt/aksel-icons");
const button_1 = require("../button");
const Theme_1 = require("../theme/Theme");
const typography_1 = require("../typography");
const composeEventHandlers_1 = require("../util/composeEventHandlers");
const copy_1 = __importDefault(require("../util/copy"));
const i18n_hooks_1 = require("../util/i18n/i18n.hooks");
/**
 * A button component that copies text to the clipboard when clicked.
 *
 * @see [📝 Documentation](https://aksel.nav.no/komponenter/core/copybutton)
 * @see 🏷️ {@link CopyButtonProps}
 *
 * @example
 * ```jsx
      <CopyButton copyText="3.14" />
 * ```
 */
exports.CopyButton = (0, react_1.forwardRef)((_a, ref) => {
    var { className, copyText, text, activeText, variant = "neutral", onActiveChange, icon, activeIcon, activeDuration = 2000, title, iconPosition = "left", onClick, size = "medium" } = _a, rest = __rest(_a, ["className", "copyText", "text", "activeText", "variant", "onActiveChange", "icon", "activeIcon", "activeDuration", "title", "iconPosition", "onClick", "size"]);
    const [active, setActive] = (0, react_1.useState)(false);
    const timeoutRef = (0, react_1.useRef)();
    const translate = (0, i18n_hooks_1.useI18n)("CopyButton");
    const { cn } = (0, Theme_1.useRenameCSS)();
    const themeContext = (0, Theme_1.useThemeInternal)(false);
    (0, react_1.useEffect)(() => {
        return () => {
            timeoutRef.current && clearTimeout(timeoutRef.current);
        };
    }, []);
    const handleClick = () => {
        timeoutRef.current && clearTimeout(timeoutRef.current);
        (0, copy_1.default)(copyText);
        setActive(true);
        onActiveChange === null || onActiveChange === void 0 ? void 0 : onActiveChange(true);
        timeoutRef.current = window.setTimeout(() => {
            setActive(false);
            onActiveChange === null || onActiveChange === void 0 ? void 0 : onActiveChange(false);
        }, activeDuration);
    };
    const activeString = activeText || translate("activeText");
    const copyIcon = (react_1.default.createElement(LegacyIconWrapper, { useLegacy: !themeContext }, active
        ? activeIcon !== null && activeIcon !== void 0 ? activeIcon : (react_1.default.createElement(aksel_icons_1.CheckmarkIcon, { "aria-hidden": !!text, title: text ? undefined : activeString, className: themeContext ? cn("navds-copybutton__icon") : undefined }))
        : icon !== null && icon !== void 0 ? icon : (react_1.default.createElement(aksel_icons_1.FilesIcon, { "aria-hidden": !!text, title: text ? undefined : title || translate("title"), className: themeContext ? cn("navds-copybutton__icon") : undefined }))));
    if (themeContext) {
        return (react_1.default.createElement(button_1.Button, Object.assign({ ref: ref, type: "button", className: cn("navds-copybutton", className) }, rest, { variant: variant === "action" ? "tertiary" : "tertiary-neutral", onClick: (0, composeEventHandlers_1.composeEventHandlers)(onClick, handleClick), iconPosition: iconPosition, icon: copyIcon, "data-active": active, size: size }), text ? (active ? activeString : text) : null));
    }
    return (react_1.default.createElement("button", Object.assign({ ref: ref, type: "button" }, rest, { className: cn("navds-copybutton", className, `navds-copybutton--${size}`, `navds-copybutton--${variant}`, {
            "navds-copybutton--icon-only": !text,
            "navds-copybutton--icon-right": iconPosition === "right",
            "navds-copybutton--active": active,
        }), onClick: (0, composeEventHandlers_1.composeEventHandlers)(onClick, handleClick) }),
        react_1.default.createElement("span", { className: cn("navds-copybutton__content") },
            iconPosition === "left" && copyIcon,
            text && (react_1.default.createElement(typography_1.Label, { as: "span", size: size === "medium" ? "medium" : "small" }, active ? activeString : text)),
            iconPosition === "right" && copyIcon)));
});
function LegacyIconWrapper({ children, useLegacy, }) {
    const { cn } = (0, Theme_1.useRenameCSS)();
    if (!useLegacy) {
        return children;
    }
    return react_1.default.createElement("span", { className: cn("navds-copybutton__icon") }, children);
}
exports.default = exports.CopyButton;
//# sourceMappingURL=CopyButton.js.map