"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.dateIsInCurrentMonth = void 0;
exports.isValidDate = isValidDate;
exports.isDateOutsideRange = isDateOutsideRange;
const date_fns_1 = require("date-fns");
const dateIsInCurrentMonth = (date, dateToCompare) => {
    return (0, date_fns_1.isThisMonth)((0, date_fns_1.setYear)(date, Number(dateToCompare.getFullYear())));
};
exports.dateIsInCurrentMonth = dateIsInCurrentMonth;
/** @private */
function isValidDate(day) {
    return !!(day && !Number.isNaN(day.getTime()) && day.getFullYear() > 999);
}
function isDateOutsideRange({ day, fromDate, toDate, }) {
    const isDateAfter = toDate && (0, date_fns_1.differenceInCalendarDays)(day, (0, date_fns_1.startOfDay)(toDate)) > 0;
    const isDateBefore = fromDate && (0, date_fns_1.differenceInCalendarDays)((0, date_fns_1.startOfDay)(fromDate), day) > 0;
    return isDateAfter || isDateBefore || false;
}
//# sourceMappingURL=check-dates.js.map