"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.disableDate = void 0;
const date_fns_1 = require("date-fns");
const Date_typeutils_1 = require("../Date.typeutils");
const disableDate = (disabledSelection, date) => {
    let result = false;
    if (disabledSelection instanceof Date) {
        return (0, date_fns_1.isSameDay)(disabledSelection, date);
    }
    if (Array.isArray(disabledSelection)) {
        for (let i = 0; i < disabledSelection.length; i++) {
            const selection = disabledSelection[i];
            if ((0, Date_typeutils_1.isDateRange)(selection)) {
                if (selection.from && selection.to) {
                    result = date >= selection.from && date <= selection.to;
                }
            }
            else if (selection instanceof Date) {
                result = (0, date_fns_1.isSameDay)(selection, date);
            }
            if (result)
                break;
        }
    }
    return result;
};
exports.disableDate = disableDate;
//# sourceMappingURL=dates-disabled.js.map