"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.DatePickerWeekNumber = void 0;
const react_1 = __importStar(require("react"));
const react_day_picker_1 = require("react-day-picker");
const button_1 = require("../../../button");
const responsive_1 = require("../../../layout/responsive");
const Theme_1 = require("../../../theme/Theme");
const typography_1 = require("../../../typography");
const Date_locale_1 = require("../../Date.locale");
const DatePickerWeekNumber = ({ week: { weekNumber, days }, onWeekNumberClick, className, style, showOnDesktop, }) => {
    const translate = (0, Date_locale_1.useDateTranslationContext)().translate;
    const { cn } = (0, Theme_1.useRenameCSS)();
    const { getModifiers } = (0, react_day_picker_1.useDayPicker)();
    const hideWeek = (0, react_1.useMemo)(() => {
        if (days.filter((day) => {
            const mods = getModifiers(day);
            return !(mods.hidden || mods.outside || mods.disabled);
        }).length === 0) {
            return true;
        }
        return false;
    }, [days, getModifiers]);
    const DisplayMode = showOnDesktop ? responsive_1.Show : responsive_1.Hide;
    if (!onWeekNumberClick || hideWeek) {
        return (react_1.default.createElement(DisplayMode, { above: "sm", asChild: true },
            react_1.default.createElement("td", { className: "rdp-cell" },
                react_1.default.createElement(typography_1.Detail, { as: "span", textColor: "subtle", className: className, style: style, "aria-label": translate("weekNumber", { week: weekNumber }) }, weekNumber))));
    }
    return (react_1.default.createElement(DisplayMode, { above: "sm", asChild: true },
        react_1.default.createElement("td", { className: cn("rdp-cell", {
                "navds-date__week-wrapper": !showOnDesktop,
            }) },
            react_1.default.createElement(button_1.Button, { variant: "secondary-neutral", size: "small", name: "week-number", "aria-label": translate("selectWeekNumber", { week: weekNumber }), style: style, className: cn("navds-date__weeknumber", "rdp-weeknumber"), onClick: () => {
                    onWeekNumberClick(weekNumber, days.map((day) => day.date));
                }, icon: react_1.default.createElement("span", { className: "navds-date__weeknumber-number" }, weekNumber) }))));
};
exports.DatePickerWeekNumber = DatePickerWeekNumber;
//# sourceMappingURL=DatePicker.WeekNumber.js.map