import React from "react";
import { OverridableComponent } from "../../../util/types";
import { GroupedHeadingProps } from "./GroupedHeading";
import { GroupedItemProps } from "./GroupedItem";
export interface GroupedListProps extends React.HTMLAttributes<HTMLDListElement> {
    /**
     * Menu list content
     */
    children: React.ReactNode;
}
export interface GroupedListType extends React.ForwardRefExoticComponent<GroupedListProps & React.RefAttributes<HTMLDListElement>> {
    /**
     * @see 🏷️ {@link GroupedHeadingProps}
     */
    Heading: React.ForwardRefExoticComponent<GroupedHeadingProps & React.RefAttributes<HTMLDetailsElement>>;
    /**
     * @see 🏷️ {@link GroupedItemProps}
     * @see [🤖 OverridableComponent](https://aksel.nav.no/grunnleggende/kode/overridablecomponent) support
     */
    Item: OverridableComponent<GroupedItemProps, HTMLButtonElement>;
}
export declare const DescriptionList: GroupedListType;
export default DescriptionList;
