import React from "react";
import { OverridableComponent } from "../../../util/types";
import { ListItemProps } from "./Item";
export interface ListProps extends React.HTMLAttributes<HTMLUListElement> {
    /**
     * Menu list content
     */
    children: React.ReactNode;
}
export interface ListType extends React.ForwardRefExoticComponent<ListProps & React.RefAttributes<HTMLUListElement>> {
    /**
     * @see 🏷️ {@link ListItemProps}
     * @see [🤖 OverridableComponent](https://aksel.nav.no/grunnleggende/kode/overridablecomponent) support
     */
    Item: OverridableComponent<ListItemProps, HTMLButtonElement>;
}
export declare const List: ListType;
export default List;
