"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Menu = void 0;
const react_1 = __importStar(require("react"));
const popover_1 = require("../../popover");
const Theme_1 = require("../../theme/Theme");
const context_1 = require("../context");
const Divider_1 = __importDefault(require("./Divider"));
const GroupedList_1 = __importDefault(require("./GroupedList"));
const List_1 = __importDefault(require("./List"));
exports.Menu = (0, react_1.forwardRef)((_a, ref) => {
    var { className, onClose, placement = "bottom-end" } = _a, rest = __rest(_a, ["className", "onClose", "placement"]);
    const { cn } = (0, Theme_1.useRenameCSS)();
    const context = (0, react_1.useContext)(context_1.DropdownContext);
    if (!context) {
        console.warn("Dropdown.Menu has to be wrapped in <Dropdown />");
        return null;
    }
    const { isOpen, anchorEl, handleToggle } = context;
    return (react_1.default.createElement(popover_1.Popover, Object.assign({}, rest, { placement: placement, ref: ref, arrow: false, className: cn("navds-dropdown__menu", className), offset: -4, anchorEl: anchorEl, open: isOpen, onClose: () => {
            handleToggle(false);
            onClose === null || onClose === void 0 ? void 0 : onClose();
        } })));
});
exports.Menu.List = List_1.default;
exports.Menu.GroupedList = GroupedList_1.default;
exports.Menu.Divider = Divider_1.default;
exports.default = exports.Menu;
//# sourceMappingURL=index.js.map