"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const aksel_icons_1 = require("@navikt/aksel-icons");
const Theme_1 = require("../theme/Theme");
const i18n_hooks_1 = require("../util/i18n/i18n.hooks");
const context_1 = require("./context");
const ExpansionCardHeader = (0, react_1.forwardRef)((_a, ref) => {
    var { children, className } = _a, rest = __rest(_a, ["children", "className"]);
    const { cn } = (0, Theme_1.useRenameCSS)();
    const panelContext = (0, react_1.useContext)(context_1.ExpansionCardContext);
    const translate = (0, i18n_hooks_1.useI18n)("global");
    if (panelContext === null) {
        console.error("<ExpansionCard.Header> has to be used within an <ExpansionCard>");
        return null;
    }
    return (react_1.default.createElement("div", Object.assign({ ref: ref }, rest, { className: cn("navds-expansioncard__header", className), "data-open": panelContext.open }),
        react_1.default.createElement("div", { className: cn("navds-expansioncard__header-content") }, children),
        react_1.default.createElement("button", { className: cn("navds-expansioncard__header-button"), onClick: panelContext.toggleOpen, type: "button", "aria-expanded": panelContext.open },
            react_1.default.createElement(aksel_icons_1.ChevronDownIcon, { className: cn("navds-expansioncard__header-chevron"), title: translate("showMore") }))));
});
exports.default = ExpansionCardHeader;
//# sourceMappingURL=ExpansionCardHeader.js.map