"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ReadOnlyIconWithTitle = exports.ReadOnlyIcon = void 0;
const react_1 = __importDefault(require("react"));
const aksel_icons_1 = require("@navikt/aksel-icons");
const Theme_1 = require("../theme/Theme");
const i18n_hooks_1 = require("../util/i18n/i18n.hooks");
const ReadOnlyIcon = () => {
    const { cn } = (0, Theme_1.useRenameCSS)();
    return (react_1.default.createElement(aksel_icons_1.PadlockLockedFillIcon, { "aria-hidden": true, className: cn("navds-form-field__readonly-icon") }));
};
exports.ReadOnlyIcon = ReadOnlyIcon;
const ReadOnlyIconWithTitle = () => {
    const { cn } = (0, Theme_1.useRenameCSS)();
    return (react_1.default.createElement(aksel_icons_1.PadlockLockedFillIcon, { title: (0, i18n_hooks_1.useI18n)("global")("readOnly"), className: cn("navds-form-field__readonly-icon") }));
};
exports.ReadOnlyIconWithTitle = ReadOnlyIconWithTitle;
//# sourceMappingURL=ReadOnlyIcon.js.map