import { CheckboxProps } from "./types";
/**
 * Handles props for Checkboxes in context with Fieldset and CheckboxGroup
 */
declare const useCheckbox: (props: CheckboxProps) => {
    readOnly: boolean | undefined;
    nested: boolean;
    inputProps: {
        checked: boolean | undefined;
        defaultChecked: boolean | undefined;
        onChange: (e: any) => void;
        onClick: (e: any) => void;
        id: string;
        "aria-invalid"?: boolean;
        "aria-describedby"?: string;
        disabled?: boolean;
    };
    showErrorMsg: boolean;
    hasError: boolean;
    errorId: string;
    inputDescriptionId: string;
    size: "small" | "medium";
};
export default useCheckbox;
