"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const Theme_1 = require("../../theme/Theme");
const Input_context_1 = require("./Input/Input.context");
const ComboboxWrapper = ({ children, className, hasError, inputProps, inputSize, toggleIsListOpen, }) => {
    const { cn } = (0, Theme_1.useRenameCSS)();
    const { toggleOpenButtonRef, clearInput, readOnly } = (0, Input_context_1.useInputContext)();
    const wrapperRef = (0, react_1.useRef)(null);
    const [hasFocusWithin, setHasFocusWithin] = (0, react_1.useState)(false);
    function onFocusInsideWrapper(event) {
        var _a;
        if (!((_a = wrapperRef.current) === null || _a === void 0 ? void 0 : _a.contains(event.relatedTarget)) &&
            (toggleOpenButtonRef === null || toggleOpenButtonRef === void 0 ? void 0 : toggleOpenButtonRef.current) !== event.target) {
            setHasFocusWithin(true);
        }
    }
    function onBlurWrapper(event) {
        var _a;
        if (!((_a = wrapperRef.current) === null || _a === void 0 ? void 0 : _a.contains(event.relatedTarget))) {
            toggleIsListOpen(false);
            setHasFocusWithin(false);
            clearInput(event);
        }
    }
    return (react_1.default.createElement("div", { ref: wrapperRef, className: cn(className, "navds-form-field", `navds-form-field--${inputSize}`, {
            "navds-combobox--error": hasError,
            "navds-combobox--disabled": !!inputProps.disabled,
            "navds-combobox--focused": hasFocusWithin,
            "navds-combobox--readonly": readOnly,
            "navds-form-field--readonly": readOnly,
        }), onFocus: onFocusInsideWrapper, onBlur: onBlurWrapper }, children));
};
exports.default = ComboboxWrapper;
//# sourceMappingURL=ComboboxWrapper.js.map