export type VirtualFocusType = {
    activeElement: HTMLElement | undefined;
    getElementById: (id: string) => HTMLElement | undefined;
    isFocusOnTheTop: () => boolean;
    isFocusOnTheBottom: () => boolean;
    moveFocusUp: () => void;
    moveFocusDown: () => void;
    moveFocusToElement: (id: string) => void;
    moveFocusToTop: () => void;
    moveFocusToBottom: () => void;
    moveFocusUpBy: (numberOfElements: number) => void;
    moveFocusDownBy: (numberOfElements: number) => void;
    resetFocus: () => void;
};
declare const useVirtualFocus: (containerRef: HTMLElement | null) => VirtualFocusType;
export default useVirtualFocus;
