"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.InputController = void 0;
/* eslint-disable jsx-a11y/no-static-element-interactions */
const react_1 = __importStar(require("react"));
const Theme_1 = require("../../../theme/Theme");
const hooks_1 = require("../../../util/hooks");
const filteredOptionsContext_1 = require("../FilteredOptions/filteredOptionsContext");
const SelectedOptions_1 = __importDefault(require("../SelectedOptions/SelectedOptions"));
const selectedOptionsContext_1 = require("../SelectedOptions/selectedOptionsContext");
const Input_1 = __importDefault(require("./Input"));
const Input_context_1 = require("./Input.context");
const ToggleListButton_1 = __importDefault(require("./ToggleListButton"));
exports.InputController = (0, react_1.forwardRef)((props, ref) => {
    const { 
    // eslint-disable-next-line @typescript-eslint/no-unused-vars -- Remove when prop has been removed from ComboboxProps.
    clearButton, 
    // eslint-disable-next-line @typescript-eslint/no-unused-vars -- Remove when prop has been removed from ComboboxProps.
    clearButtonLabel, toggleListButton = true, inputClassName, shouldShowSelectedOptions = true } = props, rest = __rest(props, ["clearButton", "clearButtonLabel", "toggleListButton", "inputClassName", "shouldShowSelectedOptions"]);
    const { cn } = (0, Theme_1.useRenameCSS)();
    const { focusInput, inputProps, size = "medium", inputRef, toggleOpenButtonRef, readOnly, } = (0, Input_context_1.useInputContext)();
    const { activeDecendantId, toggleIsListOpen } = (0, filteredOptionsContext_1.useFilteredOptionsContext)();
    const { selectedOptions } = (0, selectedOptionsContext_1.useSelectedOptionsContext)();
    const mergedInputRef = (0, hooks_1.useMergeRefs)(inputRef, ref);
    return (
    // eslint-disable-next-line jsx-a11y/click-events-have-key-events
    react_1.default.createElement("div", { className: cn("navds-combobox__wrapper-inner navds-text-field__input", {
            "navds-combobox__wrapper-inner--virtually-unfocused": activeDecendantId !== undefined,
        }), onClick: () => {
            if (inputProps.disabled || readOnly) {
                return;
            }
            toggleIsListOpen(true);
            focusInput();
        } },
        !shouldShowSelectedOptions ? (react_1.default.createElement(Input_1.default, Object.assign({ id: inputProps.id, ref: mergedInputRef, inputClassName: inputClassName, readOnly: readOnly }, rest))) : (react_1.default.createElement(SelectedOptions_1.default, { selectedOptions: selectedOptions, size: size },
            react_1.default.createElement(Input_1.default, Object.assign({ id: inputProps.id, ref: mergedInputRef, inputClassName: inputClassName, shouldShowSelectedOptions: shouldShowSelectedOptions, readOnly: readOnly }, rest)))),
        toggleListButton && react_1.default.createElement(ToggleListButton_1.default, { ref: toggleOpenButtonRef })));
});
//# sourceMappingURL=InputController.js.map