"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.toComboboxOption = exports.mapToComboboxOptionArray = exports.isInList = void 0;
/**
 *
 * @param option ComboboxOption will be compared by both label and value, while a string option is checked if it matches either the label or value in the list.
 * @param list
 */
const isInList = (option, list) => {
    if (typeof option === "string") {
        return list.some((listItem) => listItem.label === option || listItem.value === option);
    }
    return list.some((listItem) => listItem.label === option.label && listItem.value === option.value);
};
exports.isInList = isInList;
const toComboboxOption = (value) => ({
    label: value,
    value,
});
exports.toComboboxOption = toComboboxOption;
const mapToComboboxOptionArray = (options) => {
    return options === null || options === void 0 ? void 0 : options.map((option) => typeof option === "string" ? toComboboxOption(option) : option);
};
exports.mapToComboboxOptionArray = mapToComboboxOptionArray;
//# sourceMappingURL=combobox-utils.js.map