import React, { FieldsetHTMLAttributes } from "react";
import { FormFieldProps } from "../useFormField";
export interface FieldsetProps extends FormFieldProps, FieldsetHTMLAttributes<HTMLFieldSetElement> {
    /**
     * FormFields in Fieldset
     */
    children: React.ReactNode;
    /**
     * Fieldset legend
     */
    legend: React.ReactNode;
    /**
     * If enabled shows the legend and description for screenreaders only
     */
    hideLegend?: boolean;
    /**
     * Toggles error propagation to child-elements
     * @default true
     */
    errorPropagation?: boolean;
    nativeReadOnly?: boolean;
}
export declare const Fieldset: React.ForwardRefExoticComponent<FieldsetProps & React.RefAttributes<HTMLFieldSetElement>>;
export default Fieldset;
