"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const link_1 = require("../../../../link");
const download_file_1 = require("./utils/download-file");
const file_type_checker_1 = require("./utils/file-type-checker");
const ItemName = ({ file, href, onClick }) => {
    if (onClick && href) {
        return (react_1.default.createElement(link_1.Link, { href: href, onClick: onClick }, file.name));
    }
    if (onClick) {
        return (react_1.default.createElement(link_1.Link, { href: "#", onClick: (event) => {
                event.preventDefault();
                onClick(event);
            } }, file.name));
    }
    if (href) {
        return react_1.default.createElement(link_1.Link, { href: href }, file.name);
    }
    if ((0, file_type_checker_1.isNativeFile)(file)) {
        return (react_1.default.createElement(link_1.Link, { href: "#", download: file.name, onClick: (event) => {
                event.preventDefault();
                (0, download_file_1.downloadFile)(file);
            } }, file.name));
    }
    return react_1.default.createElement("span", null, file.name);
};
exports.default = ItemName;
//# sourceMappingURL=ItemName.js.map