import React from "react";
import { OverridableComponent } from "../../util/types";
export interface FormSummaryEditProps extends React.AnchorHTMLAttributes<HTMLAnchorElement> {
    /**
     * URL to the relevant part of the form, where the answers can be edited.
     */
    href?: string;
    /**
     * Link text.
     *
     * [How to write good links](https://aksel.nav.no/god-praksis/artikler/lenker).
     * @default "Endre svar"
     */
    children?: React.ReactNode;
}
export declare const FormSummaryEditLink: OverridableComponent<FormSummaryEditProps, HTMLAnchorElement>;
export default FormSummaryEditLink;
