"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Bleed = void 0;
const react_1 = __importStar(require("react"));
const Slot_1 = require("../../slot/Slot");
const Theme_1 = require("../../theme/Theme");
const css_1 = require("../utilities/css");
/**
 * Foundational Layout-primitive for generic encapsulation & styling.
 *
 * @see [📝 Documentation](https://aksel.nav.no/komponenter/primitives/Bleed)
 * @see 🏷️ {@link BleedProps}
 * @see [🤖 OverridableComponent](https://aksel.nav.no/grunnleggende/kode/overridablecomponent) support
 *
 * @example
 * <Box padding="4">
 *   <Bleed marginInline="4" marginBlock="4">
 *     <BodyLong>Some content</BodyLong>
 *   </Bleed>
 * </Box>
 */
exports.Bleed = (0, react_1.forwardRef)((_a, ref) => {
    var { className, marginInline, marginBlock, reflectivePadding, style: _style, asChild } = _a, rest = __rest(_a, ["className", "marginInline", "marginBlock", "reflectivePadding", "style", "asChild"]);
    const themeContext = (0, Theme_1.useThemeInternal)(false);
    const { cn } = (0, Theme_1.useRenameCSS)();
    const prefix = themeContext ? "ax" : "a";
    let style = Object.assign(Object.assign(Object.assign({}, _style), (0, css_1.getResponsiveProps)(prefix, "bleed", "margin-inline", "spacing", marginInline, true, ["0", "full", "px"])), (0, css_1.getResponsiveProps)(prefix, "bleed", "margin-block", "spacing", marginBlock, true, ["0", "px"]));
    if (reflectivePadding) {
        style = Object.assign(Object.assign(Object.assign({}, style), (0, css_1.getResponsiveProps)(prefix, "bleed", "padding-inline", "spacing", marginInline, false, ["0", "full", "px"])), (0, css_1.getResponsiveProps)(prefix, "bleed", "padding-block", "spacing", marginBlock, false, ["0", "px"]));
    }
    const Comp = asChild ? Slot_1.Slot : "div";
    return (react_1.default.createElement(Comp, Object.assign({}, rest, { className: cn("navds-bleed", className, {
            "navds-bleed--padding": reflectivePadding,
        }), ref: ref, style: style })));
});
exports.default = exports.Bleed;
//# sourceMappingURL=Bleed.js.map