"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Stack = void 0;
const react_1 = __importStar(require("react"));
const Slot_1 = require("../../slot/Slot");
const Theme_1 = require("../../theme/Theme");
const util_1 = require("../../util");
const BasePrimitive_1 = __importStar(require("../base/BasePrimitive"));
const css_1 = require("../utilities/css");
exports.Stack = (0, react_1.forwardRef)((_a, ref) => {
    var { children, className, as: Component = "div", align, justify, wrap = true, gap, style: _style, direction = "row", asChild } = _a, rest = __rest(_a, ["children", "className", "as", "align", "justify", "wrap", "gap", "style", "direction", "asChild"]);
    const themeContext = (0, Theme_1.useThemeInternal)(false);
    const prefix = themeContext ? "ax" : "a";
    const { cn } = (0, Theme_1.useRenameCSS)();
    const style = Object.assign(Object.assign(Object.assign(Object.assign(Object.assign({}, _style), (0, css_1.getResponsiveProps)(prefix, `stack`, "gap", "spacing", gap)), (0, css_1.getResponsiveValue)(prefix, `stack`, "direction", direction)), (0, css_1.getResponsiveValue)(prefix, `stack`, "align", align)), (0, css_1.getResponsiveValue)(prefix, `stack`, "justify", justify));
    const Comp = asChild ? Slot_1.Slot : Component;
    return (react_1.default.createElement(BasePrimitive_1.default, Object.assign({}, rest),
        react_1.default.createElement(Comp, Object.assign({}, (0, util_1.omit)(rest, BasePrimitive_1.PRIMITIVE_PROPS), { ref: ref, style: style, className: cn("navds-stack", className, {
                "navds-vstack": direction === "column",
                "navds-hstack": direction === "row",
                "navds-stack-gap": gap,
                "navds-stack-align": align,
                "navds-stack-justify": justify,
                "navds-stack-direction": direction,
                "navds-stack-wrap": wrap,
            }) }), children)));
});
exports.default = exports.Stack;
//# sourceMappingURL=Stack.js.map