"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Loader = void 0;
const react_1 = __importStar(require("react"));
const Theme_1 = require("../theme/Theme");
const util_1 = require("../util");
const hooks_1 = require("../util/hooks");
const i18n_hooks_1 = require("../util/i18n/i18n.hooks");
/**
 * A component that displays a loading spinner.
 *
 * @see [📝 Documentation](https://aksel.nav.no/komponenter/core/loader)
 * @see 🏷️ {@link LoaderProps}
 *
 * @example
 * ```jsx
 * <Loader size="3xlarge" title="Venter…" />
 * ```
 */
exports.Loader = (0, react_1.forwardRef)((_a, ref) => {
    var { className, size = "medium", title, transparent = false, variant = "neutral", id, "data-color": color } = _a, rest = __rest(_a, ["className", "size", "title", "transparent", "variant", "id", "data-color"]);
    const { cn } = (0, Theme_1.useRenameCSS)();
    const internalId = (0, hooks_1.useId)();
    const translate = (0, i18n_hooks_1.useI18n)("Loader");
    return (react_1.default.createElement("svg", Object.assign({ "aria-labelledby": id !== null && id !== void 0 ? id : `loader-${internalId}`, ref: ref, className: cn("navds-loader", className, `navds-loader--${size}`, `navds-loader--${variant}`, {
            "navds-loader--transparent": transparent,
        }), focusable: "false", viewBox: "0 0 50 50", preserveAspectRatio: "xMidYMid", "data-color": color !== null && color !== void 0 ? color : variantToColor(variant) }, (0, util_1.omit)(rest, ["children"]), { "data-variant": variant }),
        react_1.default.createElement("title", { id: id !== null && id !== void 0 ? id : `loader-${internalId}` }, title || translate("title")),
        react_1.default.createElement("circle", { className: cn("navds-loader__background"), xmlns: "http://www.w3.org/2000/svg", cx: "25", cy: "25", r: "20", fill: "none" }),
        react_1.default.createElement("circle", { className: cn("navds-loader__foreground"), cx: "25", cy: "25", r: "20", fill: "none", strokeDasharray: "50 155" })));
});
function variantToColor(variant) {
    switch (variant) {
        case "neutral":
            return "neutral";
        case "inverted":
            return "neutral";
        /* We assume "interaction" is the main app color in this instance */
        case "interaction":
            return undefined;
        default:
            return "neutral";
    }
}
exports.default = exports.Loader;
//# sourceMappingURL=Loader.js.map