"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useEscapeKeydown = useEscapeKeydown;
const react_1 = require("react");
const hooks_1 = require("../../../util/hooks");
function useEscapeKeydown(callback, ownerDocument = globalThis === null || globalThis === void 0 ? void 0 : globalThis.document) {
    const onEscapeKeyDown = (0, hooks_1.useCallbackRef)(callback);
    (0, react_1.useEffect)(() => {
        const handleKeyDown = (event) => {
            if (event.key === "Escape") {
                onEscapeKeyDown(event);
            }
        };
        ownerDocument.addEventListener("keydown", handleKeyDown, true);
        return () => ownerDocument.removeEventListener("keydown", handleKeyDown, true);
    }, [onEscapeKeyDown, ownerDocument]);
}
//# sourceMappingURL=useEscapeKeydown.js.map