import React from "react";
import { ButtonProps } from "../button";
import { OverridableComponent } from "../util/types";
export interface PaginationItemProps extends ButtonProps {
    children: React.ReactNode;
    /**
     * Sets selected styling if true
     * @default false
     */
    selected?: boolean;
    /**
     * Currently only sets `data-page` attribute.
     * @deprecated Use `data-page` instead if you need to access the items page number in the future.
     */
    page?: number;
    /**
     * Changes padding, height and font-size
     * @default "medium"
     */
    size?: "medium" | "small" | "xsmall";
}
export type PaginationItemType = OverridableComponent<PaginationItemProps, HTMLAnchorElement>;
export declare const Item: PaginationItemType;
export default Item;
