"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Portal = void 0;
const react_1 = __importStar(require("react"));
const react_dom_1 = __importDefault(require("react-dom"));
const Provider_1 = require("../provider/Provider");
const Slot_1 = require("../slot/Slot");
const Theme_1 = require("../theme/Theme");
exports.Portal = (0, react_1.forwardRef)((_a, ref) => {
    var _b, _c, _d;
    var { rootElement, asChild } = _a, rest = __rest(_a, ["rootElement", "asChild"]);
    const themeContext = (0, Theme_1.useThemeInternal)(false);
    const contextRoot = (_b = (0, Provider_1.useProvider)()) === null || _b === void 0 ? void 0 : _b.rootElement;
    const root = (_c = rootElement !== null && rootElement !== void 0 ? rootElement : contextRoot) !== null && _c !== void 0 ? _c : (_d = globalThis === null || globalThis === void 0 ? void 0 : globalThis.document) === null || _d === void 0 ? void 0 : _d.body;
    const Component = asChild ? Slot_1.Slot : "div";
    /**
     * Portal can be mounted outside of theme-classNames.
     * If a theme is present, we want to make sure that theme cascades to portaled element.
     */
    if (themeContext) {
        return root
            ? react_dom_1.default.createPortal(react_1.default.createElement(Theme_1.Theme, { theme: themeContext.theme, asChild: true, hasBackground: false, "data-color": themeContext.color },
                react_1.default.createElement(Component, Object.assign({ ref: ref, "data-aksel-portal": "" }, rest))), root)
            : null;
    }
    return root
        ? react_dom_1.default.createPortal(react_1.default.createElement(Component, Object.assign({ ref: ref, "data-aksel-portal": "" }, rest)), root)
        : null;
});
exports.default = exports.Portal;
//# sourceMappingURL=Portal.js.map