import React from "react";
import { OverridableComponent } from "../util/types";
export interface StepperStepProps extends React.AnchorHTMLAttributes<HTMLAnchorElement> {
    /**
     * Text content by indicator.
     */
    children: string;
    /**
     * Makes step-indicator a checkmark.
     * @default false
     */
    completed?: boolean;
    /**
     * Makes step non-interactive if false. Step will be set to a `<div>`, overriding `as`-prop.
     * @default true
     */
    interactive?: boolean;
}
export declare const Step: OverridableComponent<StepperStepProps, HTMLAnchorElement>;
export default Step;
