import React from "react";
import { OverridableComponent } from "../../../util";
export interface TabProps extends Omit<React.ButtonHTMLAttributes<HTMLButtonElement>, "children"> {
    /**
     * Tab label.
     */
    label?: React.ReactNode;
    /**
     * Tab Icon.
     */
    icon?: React.ReactNode;
    /**
     * Value for state-handling.
     */
    value: string;
    /**
     * Overrides auto-generated id.
     *
     * **Warning**: Tab generates an id if not provided. If you need to override it,
     * make sure to also include the correct `aria-controls` id for the TabPanel it controls.
     */
    id?: string;
}
export declare const Tab: OverridableComponent<TabProps, HTMLButtonElement>;
export default Tab;
