"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Tab = void 0;
const react_1 = __importStar(require("react"));
const Theme_1 = require("../../../theme/Theme");
const typography_1 = require("../../../typography");
const Tabs_context_1 = require("../../Tabs.context");
const useTab_1 = require("./useTab");
exports.Tab = (0, react_1.forwardRef)((_a, ref) => {
    var _b, _c;
    var { className, as: Component = "button", label, icon, value, onClick, onFocus, disabled, id } = _a, rest = __rest(_a, ["className", "as", "label", "icon", "value", "onClick", "onFocus", "disabled", "id"]);
    const { cn } = (0, Theme_1.useRenameCSS)();
    const tabCtx = (0, useTab_1.useTab)({ value, onClick, onFocus, disabled }, ref);
    const ctx = (0, Tabs_context_1.useTabsContext)();
    if (!label && !icon) {
        console.error("<Tabs.Tab/> needs label and/or icon");
        return null;
    }
    return (react_1.default.createElement(Component, Object.assign({ ref: tabCtx.ref }, rest, { className: cn("navds-tabs__tab", `navds-tabs__tab--${(_b = ctx === null || ctx === void 0 ? void 0 : ctx.size) !== null && _b !== void 0 ? _b : "medium"}`, `navds-tabs__tab-icon--${ctx === null || ctx === void 0 ? void 0 : ctx.iconPosition}`, className, {
            "navds-tabs__tab--icon-only": icon && !label,
            "navds-tabs__tab--fill": ctx.fill,
        }), role: "tab", type: "button", "aria-selected": tabCtx.isSelected, "data-state": tabCtx.isSelected ? "active" : "inactive", tabIndex: tabCtx.isFocused ? 0 : -1, "aria-controls": (_c = rest["aria-controls"]) !== null && _c !== void 0 ? _c : tabCtx.controlsId, id: id !== null && id !== void 0 ? id : tabCtx.id, onFocus: tabCtx.onFocus, onClick: tabCtx.onClick }),
        react_1.default.createElement(typography_1.BodyShort, { as: "span", className: cn("navds-tabs__tab-inner"), size: ctx === null || ctx === void 0 ? void 0 : ctx.size },
            react_1.default.createElement("span", { "aria-hidden": !!label }, icon),
            react_1.default.createElement("span", null, label))));
});
exports.default = exports.Tab;
//# sourceMappingURL=Tab.js.map