"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TabList = void 0;
/* eslint-disable jsx-a11y/interactive-supports-focus */
const react_1 = __importStar(require("react"));
const Theme_1 = require("../../../theme/Theme");
const composeEventHandlers_1 = require("../../../util/composeEventHandlers");
const useMergeRefs_1 = require("../../../util/hooks/useMergeRefs");
const ScrollButtons_1 = __importDefault(require("./ScrollButtons"));
const useScrollButtons_1 = require("./useScrollButtons");
const useTabList_1 = require("./useTabList");
exports.TabList = (0, react_1.forwardRef)((_a, ref) => {
    var { className, onKeyDown } = _a, rest = __rest(_a, ["className", "onKeyDown"]);
    const { cn } = (0, Theme_1.useRenameCSS)();
    const { onKeyDown: _onKeyDown } = (0, useTabList_1.useTabList)();
    const listRef = (0, react_1.useRef)(null);
    const mergedRef = (0, useMergeRefs_1.useMergeRefs)(listRef, ref);
    const scrollCtx = (0, useScrollButtons_1.useScrollButtons)(listRef);
    return (react_1.default.createElement("div", { className: cn("navds-tabs__tablist-wrapper") },
        scrollCtx.show && (react_1.default.createElement(ScrollButtons_1.default, { dir: "left", hidden: !scrollCtx.start, onClick: scrollCtx.scrollLeft })),
        react_1.default.createElement("div", Object.assign({ ref: mergedRef }, rest, { onScroll: scrollCtx.update, className: cn("navds-tabs__tablist", className), role: "tablist", "aria-orientation": "horizontal", onKeyDown: (0, composeEventHandlers_1.composeEventHandlers)(onKeyDown, _onKeyDown) })),
        scrollCtx.show && (react_1.default.createElement(ScrollButtons_1.default, { dir: "right", hidden: !scrollCtx.end, onClick: scrollCtx.scrollRight }))));
});
exports.default = exports.TabList;
//# sourceMappingURL=TabList.js.map