"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TimelineRow = void 0;
const date_fns_1 = require("date-fns");
const react_1 = __importStar(require("react"));
const Theme_1 = require("../theme/Theme");
const BodyShort_1 = require("../typography/BodyShort");
const i18n_hooks_1 = require("../util/i18n/i18n.hooks");
const usePeriodContext_1 = require("./hooks/usePeriodContext");
const useRowContext_1 = require("./hooks/useRowContext");
const useTimelineContext_1 = require("./hooks/useTimelineContext");
const period_1 = __importDefault(require("./period"));
exports.TimelineRow = (0, react_1.forwardRef)((_a, ref) => {
    var { label, className, headingTag = "h3", icon } = _a, rest = __rest(_a, ["label", "className", "headingTag", "icon"]);
    const { cn } = (0, Theme_1.useRenameCSS)();
    const { periods, id, active } = (0, useRowContext_1.useRowContext)();
    const { setActiveRow } = (0, useTimelineContext_1.useTimelineContext)();
    const translate = (0, i18n_hooks_1.useI18n)("Timeline");
    const latest = periods.reduce((a, b) => {
        return a.end > b.end ? a : b;
    }, {});
    const earliest = periods.reduce((a, b) => {
        return a.end < b.end ? a : b;
    }, {});
    const firstFocusable = periods.find((p) => !!p.children || !!p.onSelectPeriod);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        label && (react_1.default.createElement(BodyShort_1.BodyShort, { as: headingTag, id: `timeline-row-${id}`, className: cn("navds-timeline__row-label"), size: "small" },
            icon,
            label)),
        react_1.default.createElement("div", { className: cn("navds-timeline__row", {
                "navds-timeline__row--active": active,
            }) },
            react_1.default.createElement("ol", Object.assign({}, rest, { tabIndex: -1, ref: ref, "aria-label": periods.length === 0
                    ? translate("Row.noPeriods")
                    : translate("Row.period", {
                        start: (0, date_fns_1.format)(earliest.start, translate("dateFormat")),
                        end: (0, date_fns_1.format)(latest.end, translate("dateFormat")),
                    }), className: cn("navds-timeline__row-periods", className), onKeyDown: (e) => {
                    if (e.key === "ArrowDown" || e.key === "ArrowUp") {
                        e.preventDefault();
                        setActiveRow(e.key);
                    }
                } }), periods === null || periods === void 0 ? void 0 : periods.map((period) => {
                return (react_1.default.createElement("li", { key: `period-${period.id}` },
                    react_1.default.createElement(usePeriodContext_1.PeriodContext.Provider, { value: {
                            periodId: period.id,
                            firstFocus: (firstFocusable === null || firstFocusable === void 0 ? void 0 : firstFocusable.id) === period.id,
                            restProps: period === null || period === void 0 ? void 0 : period.restProps,
                        } },
                        react_1.default.createElement(period_1.default, { start: period.start, end: period.endInclusive, icon: period.icon, ref: period === null || period === void 0 ? void 0 : period.ref }))));
            })))));
});
exports.TimelineRow.componentType = "row";
exports.default = exports.TimelineRow;
//# sourceMappingURL=TimelineRow.js.map