"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useTimelineContext = exports.TimelineContext = void 0;
const react_1 = require("react");
exports.TimelineContext = (0, react_1.createContext)({
    startDate: new Date(),
    endDate: new Date(),
    direction: "left",
    setStart: () => null,
    setEndInclusive: () => null,
    activeRow: 0,
    setActiveRow: () => null,
    initiate: () => null,
    addFocusable: () => null,
});
const useTimelineContext = () => {
    const context = (0, react_1.useContext)(exports.TimelineContext);
    if (!context) {
        console.warn("useTimelineContext must be used with TimelineContext (<Timeline />)");
    }
    return context;
};
exports.useTimelineContext = useTimelineContext;
//# sourceMappingURL=useTimelineContext.js.map