import React from "react";
export interface TimelineZoomButtonProps {
    /**
     * e.g 3mnd, 6mnd etc
     */
    label: string;
    /**
     * Zoom interval in months or years
     */
    interval: "month" | "year";
    /**
     * How many units of the interval that will be applied
     * e.g interval="month" + count={3} equals 3 months
     */
    count: number;
}
export type ZoomButtonType = React.ForwardRefExoticComponent<TimelineZoomButtonProps & React.RefAttributes<HTMLButtonElement>>;
export declare const ZoomButton: ZoomButtonType;
export default ZoomButton;
