"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ZoomButton = void 0;
const date_fns_1 = require("date-fns");
const react_1 = __importStar(require("react"));
const Theme_1 = require("../../theme/Theme");
const Detail_1 = require("../../typography/Detail");
const i18n_hooks_1 = require("../../util/i18n/i18n.hooks");
const useTimelineContext_1 = require("../hooks/useTimelineContext");
exports.ZoomButton = (0, react_1.forwardRef)((_a, ref) => {
    var { label, interval, count } = _a, rest = __rest(_a, ["label", "interval", "count"]);
    const { setStart, endDate, startDate, direction } = (0, useTimelineContext_1.useTimelineContext)();
    const translate = (0, i18n_hooks_1.useI18n)("Timeline");
    const dateFormat = translate("dateFormat");
    const { cn } = (0, Theme_1.useRenameCSS)();
    let startOfRange;
    if (interval === "month") {
        startOfRange =
            direction === "left"
                ? (0, date_fns_1.subMonths)(endDate, count)
                : (0, date_fns_1.addMonths)(startDate, count);
    }
    else {
        startOfRange =
            direction === "left"
                ? (0, date_fns_1.subYears)(endDate, count)
                : (0, date_fns_1.addYears)(startDate, count);
    }
    const currentZoom = direction === "left"
        ? (0, date_fns_1.isSameDay)(startDate, startOfRange)
        : (0, date_fns_1.isSameDay)(endDate, startOfRange);
    return (react_1.default.createElement(Detail_1.Detail, { as: "li" },
        react_1.default.createElement("button", Object.assign({ type: "button", "aria-label": !currentZoom
                ? translate("Zoom.zoom", {
                    start: (0, date_fns_1.format)(startOfRange, dateFormat),
                    end: (0, date_fns_1.format)(endDate, dateFormat),
                })
                : translate("Zoom.reset"), ref: ref }, rest, { className: cn("navds-timeline__zoom-button"), onClick: () => {
                setStart(startOfRange);
            }, "aria-pressed": currentZoom }), label)));
});
exports.default = exports.ZoomButton;
//# sourceMappingURL=ZoomButton.js.map