import React from "react";
interface TextareaAutosizeProps extends Omit<React.TextareaHTMLAttributes<HTMLTextAreaElement>, "children" | "rows"> {
    /**
     * Maximum number of rows to display.
     */
    maxRows?: number;
    /**
     * Minimum number of rows to display.
     * @default 1
     */
    minRows?: number;
    /**
     * If true, textarea will never get `overflow:hidden`
     */
    autoScrollbar?: boolean;
}
declare const TextareaAutosize: React.ForwardRefExoticComponent<TextareaAutosizeProps & React.RefAttributes<HTMLTextAreaElement>>;
export default TextareaAutosize;
