"use strict";
"use client";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useEventListener = void 0;
const react_1 = require("react");
/* https://github.com/streamich/react-use/blob/master/src/useEvent.ts */
const useEventListener = (name, handler, target = typeof window !== "undefined" ? window : null) => {
    (0, react_1.useEffect)(() => {
        if (!target) {
            return;
        }
        target === null || target === void 0 ? void 0 : target.addEventListener(name, handler);
        return () => {
            target === null || target === void 0 ? void 0 : target.removeEventListener(name, handler);
        };
    }, [name, handler, target]);
};
exports.useEventListener = useEventListener;
//# sourceMappingURL=useEventListener.js.map