"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.requireReactElement = void 0;
const react_1 = __importDefault(require("react"));
const requireReactElement = (children) => {
    const isReactElement = react_1.default.isValidElement(children);
    if (!isReactElement) {
        throw Error(`Expected a single React Element child, but got: ${react_1.default.Children.toArray(children)
            .map((child) => typeof child === "object" &&
            "type" in child &&
            typeof child.type === "string"
            ? child.type
            : typeof child)
            .join(", ")}`);
    }
    return children;
};
exports.requireReactElement = requireReactElement;
//# sourceMappingURL=requireReactElement.js.map