"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.VirtualFocusAnchor = void 0;
const react_1 = __importStar(require("react"));
const Slot_1 = require("../../../slot/Slot");
const composeEventHandlers_1 = require("../../composeEventHandlers");
const hooks_1 = require("../../hooks");
const Context_1 = require("../Context");
/**
 * Must have a single child that is an input element.
 */
exports.VirtualFocusAnchor = (0, react_1.forwardRef)((_a, ref) => {
    var { onSelect, onActive, children } = _a, rest = __rest(_a, ["onSelect", "onActive", "children"]);
    const { virtualFocusIdx, setVirtualFocusIdx, loop, uniqueId } = (0, Context_1.useVirtualFocusInternalContext)();
    const { register, descendants, index } = (0, Context_1.useVirtualFocusDescendant)({
        handleOnActive: () => {
            setVirtualFocusIdx(0);
            onActive();
        },
        handleOnSelect: onSelect,
    });
    const mergedRefs = (0, hooks_1.useMergeRefs)(ref, register);
    return (react_1.default.createElement(Slot_1.Slot, Object.assign({ ref: mergedRefs, tabIndex: 0 }, rest, { id: `virtualfocus-${uniqueId}-${index}`, "aria-owns": `virtualfocus-${uniqueId}-content`, "aria-controls": `virtualfocus-${uniqueId}-content`, "aria-activedescendant": `virtualfocus-${uniqueId}-${virtualFocusIdx}`, onKeyDown: (0, composeEventHandlers_1.composeEventHandlers)(rest.onKeyDown, (event) => {
            if (event.key === "ArrowDown") {
                event.preventDefault();
                const to_focus_descendant = descendants.next(virtualFocusIdx, loop);
                if (to_focus_descendant) {
                    to_focus_descendant.handleOnActive();
                }
            }
            else if (event.key === "ArrowUp") {
                event.preventDefault();
                const to_focus_descendant = descendants.prev(virtualFocusIdx, loop);
                if (to_focus_descendant) {
                    to_focus_descendant.handleOnActive();
                }
            }
            else if (event.key === "Enter") {
                const curr = descendants.item(virtualFocusIdx);
                if (curr === null || curr === void 0 ? void 0 : curr.handleOnSelect) {
                    curr.handleOnSelect();
                }
            }
        }) }), children));
});
//# sourceMappingURL=VirtualFocusAnchor.js.map