"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.VirtualFocusItem = void 0;
const react_1 = __importStar(require("react"));
const Slot_1 = require("../../../slot/Slot");
const composeEventHandlers_1 = require("../../composeEventHandlers");
const hooks_1 = require("../../hooks");
const Context_1 = require("../Context");
/**
 * Contains an item you want to be iterable via virtual focus.
 */
exports.VirtualFocusItem = (0, react_1.forwardRef)((_a, ref) => {
    var { children, onActive, onSelect } = _a, rest = __rest(_a, ["children", "onActive", "onSelect"]);
    const { virtualFocusIdx, setVirtualFocusIdx, uniqueId } = (0, Context_1.useVirtualFocusInternalContext)();
    const { register, index } = (0, Context_1.useVirtualFocusDescendant)({
        handleOnActive: () => {
            setVirtualFocusIdx(index);
            onActive();
        },
        handleOnSelect: onSelect,
    });
    const mergedRefs = (0, hooks_1.useMergeRefs)(ref, register);
    return (react_1.default.createElement(Slot_1.Slot, Object.assign({ ref: mergedRefs }, rest, { id: `virtualfocus-${uniqueId}-${index}`, "data-aksel-virtualfocus": virtualFocusIdx === index, tabIndex: -1, onClick: (0, composeEventHandlers_1.composeEventHandlers)(rest.onClick, () => {
            onSelect();
        }), onMouseMove: (0, composeEventHandlers_1.composeEventHandlers)(rest.onMouseMove, () => {
            setVirtualFocusIdx(index);
            onActive();
        }) }), children));
});
//# sourceMappingURL=VirtualFocusItem.js.map