import React from "react";
export interface AccordionItemProps extends React.HTMLAttributes<HTMLDivElement> {
    /**
     * Content in Accordion.Item
     * Should include one Accordion.Header and one Accordion.Content
     */
    children: React.ReactNode;
    /**
     * Controlled open-state
     * Using this removes automatic control of open-state
     */
    open?: boolean;
    /**
     * Defaults the accordion to open if not controlled
     * @default false
     */
    defaultOpen?: boolean;
    /**
     * Callback for current open-state
     */
    onOpenChange?: (open: boolean) => void;
}
export interface AccordionItemContextProps {
    open: boolean;
    toggleOpen: () => void;
}
export declare const AccordionItemContext: React.Context<AccordionItemContextProps | null>;
declare const AccordionItem: React.ForwardRefExoticComponent<AccordionItemProps & React.RefAttributes<HTMLDivElement>>;
export default AccordionItem;
