import React from "react";
import { OverridableComponent } from "../util/types/index.js";
export interface ChipsToggleProps extends React.ButtonHTMLAttributes<HTMLButtonElement> {
    children: string;
    /**
     * Toggles aria-pressed and visual changes
     */
    selected?: boolean;
    /**
     * Chip-variants
     * @default "action"
     */
    variant?: "action" | "neutral";
    /**
     * Toggles display of checkmark on selected
     * @default true
     */
    checkmark?: boolean;
}
export declare const ToggleChips: OverridableComponent<ChipsToggleProps, HTMLButtonElement>;
export default ToggleChips;
