import React from "react";
export interface CollapsibleTriggerProps extends Omit<React.ButtonHTMLAttributes<HTMLButtonElement>, "id" | "aria-controls" | "aria-expanded"> {
    /**
     * When true, will render element as its child. This merges classes, styles and event handlers.
     * @default false
     */
    asChild?: boolean;
    /**
     * You may disable aria-expanded if the accessable name of the trigger is changed when toggled, e.g. "Show"/"Hide".
     */
    "aria-expanded"?: undefined;
}
export declare const CollapsibleTrigger: React.ForwardRefExoticComponent<CollapsibleTriggerProps & React.RefAttributes<HTMLButtonElement>>;
export default CollapsibleTrigger;
