import React, { InputHTMLAttributes } from "react";
import { FormFieldProps } from "../form/useFormField.js";
interface DateInputContextProps {
    /**
     * Open state for popover
     */
    open: boolean;
    /**
     * Callback for onOpen toggle
     */
    onOpen: () => void;
    /**
     * Aria-connected ID
     */
    ariaId?: string;
    /**
     * Flag for enabled-check
     */
    defined: boolean;
}
export declare const DateInputContextProvider: React.ForwardRefExoticComponent<DateInputContextProps & {
    children: React.ReactNode;
} & React.RefAttributes<unknown>>, useDateInputContext: <S extends boolean = true>(strict?: S) => S extends true ? DateInputContextProps : DateInputContextProps | undefined;
export interface DateInputProps extends FormFieldProps, Omit<InputHTMLAttributes<HTMLInputElement>, "size"> {
    /**
     * Input label
     */
    label: React.ReactNode;
    /**
     * Shows label and description for screen readers only
     * @default false
     */
    hideLabel?: boolean;
    /**
     * Changes padding and font-sizes
     * @default "medium"
     */
    size?: "medium" | "small";
    /**
     * @private
     */
    variant?: "datepicker" | "monthpicker";
    /**
     * @private
     */
    setAnchorRef?: React.Dispatch<React.SetStateAction<HTMLButtonElement | null>>;
}
export declare const DatePickerInput: React.ForwardRefExoticComponent<DateInputProps & React.RefAttributes<HTMLInputElement>>;
export declare const MonthPickerInput: React.ForwardRefExoticComponent<DateInputProps & React.RefAttributes<HTMLInputElement>>;
export {};
