import React from "react";
import { DatePickerDefaultProps, MultipleMode, RangeMode, SingleMode } from "../DatePicker.types.js";
interface DatePickerStandaloneDefaultProps extends Omit<DatePickerDefaultProps, "open" | "onClose" | "onOpenToggle" | "wrapperClassName" | "strategy"> {
    /**
     * Datepicker classname
     */
    className?: string;
    /**
     * If datepicker should be fixed to 6 weeks, regardless of actual weeks in month
     * @default true
     */
    fixedWeeks?: boolean;
}
type StandaloneConditionalModeProps = SingleMode | MultipleMode | RangeMode;
export type DatePickerStandaloneProps = DatePickerStandaloneDefaultProps & StandaloneConditionalModeProps;
export type DatePickerStandaloneType = React.ForwardRefExoticComponent<DatePickerStandaloneProps & React.RefAttributes<HTMLDivElement>>;
export declare const DatePickerStandalone: DatePickerStandaloneType;
export default DatePickerStandalone;
