import React from "react";
import { GroupedListType } from "./GroupedList/index.js";
import { ListType } from "./List/index.js";
interface DropdownMenuProps extends React.HTMLAttributes<HTMLDivElement> {
    /**
     * Dropdown content
     */
    children: React.ReactNode;
    /**
     * onClose callback
     */
    onClose?: () => void;
    /**
     * Popover positionion strategy
     * @default "absolute"
     */
    strategy?: "fixed" | "absolute";
    placement?: "top" | "bottom" | "right" | "left" | "top-start" | "top-end" | "bottom-start" | "bottom-end" | "right-start" | "right-end" | "left-start" | "left-end";
}
export interface MenuType<Props = DropdownMenuProps> extends React.ForwardRefExoticComponent<Props & React.RefAttributes<HTMLDivElement>> {
    /**
     * @see 🏷️ {@link ListType}
     */
    List: ListType;
    /**
     * @see 🏷️ {@link GroupedListType}
     */
    GroupedList: GroupedListType;
    /**
     * @see 🏷️ {@link React.HTMLAttributes<HTMLHRElement>}
     */
    Divider: React.ForwardRefExoticComponent<React.HTMLAttributes<HTMLHRElement> & React.RefAttributes<HTMLHRElement>>;
}
export declare const Menu: MenuType;
export default Menu;
