import React from "react";
import { Loader } from "../../../loader/index.js";
import { useRenameCSS } from "../../../theme/Theme.js";
import { useI18n } from "../../../util/i18n/i18n.hooks.js";
import { useInputContext } from "../Input/Input.context.js";
import filteredOptionsUtil from "./filtered-options-util.js";
const LoadingMessage = () => {
    const { inputProps: { id }, } = useInputContext();
    const { cn } = useRenameCSS();
    const translate = useI18n("Combobox");
    return (React.createElement("div", { className: cn("navds-combobox__list-item--loading"), id: filteredOptionsUtil.getIsLoadingId(id) },
        React.createElement(Loader, { title: translate("loading") })));
};
export default LoadingMessage;
//# sourceMappingURL=LoadingMessage.js.map