import React from "react";
import { HeadingProps } from "../../typography/index.js";
export interface FormSummaryHeadingProps extends React.HTMLAttributes<HTMLHeadingElement> {
    /**
     * Heading text.
     */
    children: React.ReactNode;
    /**
     * The heading level.
     */
    level: Exclude<HeadingProps["level"], "1">;
}
export declare const FormSummaryHeading: React.ForwardRefExoticComponent<FormSummaryHeadingProps & React.RefAttributes<HTMLHeadingElement>>;
export default FormSummaryHeading;
