import { RadioProps } from "./types.js";
/**
 * Handles props for Radios in context with Fieldset and RadioGroup
 */
export declare const useRadio: (props: RadioProps) => {
    readOnly: boolean | undefined;
    inputProps: {
        name: string | undefined;
        defaultChecked: boolean | undefined;
        checked: boolean | undefined;
        onChange: (e: any) => void;
        onClick: (e: any) => void;
        required: boolean | undefined;
        type: string;
        id: string;
        "aria-invalid"?: boolean;
        "aria-describedby"?: string;
        disabled?: boolean;
    };
    showErrorMsg: boolean;
    hasError: boolean;
    errorId: string;
    inputDescriptionId: string;
    size: "small" | "medium";
};
