import React from "react";
import { ListItem } from "./List.Item.js";
import type { ListProps } from "./List.types.js";
export interface ListComponent extends React.ForwardRefExoticComponent<ListProps & React.RefAttributes<HTMLDivElement>> {
    /**
     * @see 🏷️ {@link ListItemProps}
     */
    Item: typeof ListItem;
}
/**
 * A list component
 *
 * @see [📝 Documentation](https://aksel.nav.no/komponenter/core/list)
 * @see 🏷️ {@link ListProps | Props}
 *
 * @example
 * ```jsx
 * <List>
 *   <List.Item>Coffee</List.Item>
 *   <List.Item>Tea</List.Item>
 *   <List.Item>Milk</List.Item>
 * </List>
 * ```
 */
export declare const List: ListComponent;
export default List;
