import React from "react";
export interface HeaderCellProps extends React.ThHTMLAttributes<HTMLTableCellElement> {
    scope?: string;
    /**
     * Content alignment inside cell
     * @default "left"
     */
    align?: "left" | "center" | "right";
    /**
     * Adjusts font-size
     */
    textSize?: "medium" | "small";
}
export type HeaderCellType = React.ForwardRefExoticComponent<HeaderCellProps & React.RefAttributes<HTMLTableCellElement>>;
export declare const HeaderCell: HeaderCellType;
export default HeaderCell;
