import React from "react";
export interface TabPanelProps extends React.HTMLAttributes<HTMLDivElement> {
    /**
     * Tab panel content.
     */
    children: React.ReactNode;
    /**
     * Value for state-handling.
     */
    value: string;
    /**
     * If true, will only render children when selected.
     * @default true
     */
    lazy?: boolean;
    /**
     * Overrides auto-generated id.
     *
     * **Warning**: TabPanel generates an id if not provided. If you need to override it,
     * make sure to also include the correct `aria-labelledby` id for the Tab that labels it.
     */
    id?: string;
}
declare const TabPanel: React.ForwardRefExoticComponent<TabPanelProps & React.RefAttributes<HTMLDivElement>>;
export default TabPanel;
