import React from "react";
import { TimelineComponentTypes } from "./utils/types.internal.js";
export interface TimelineRowProps extends React.HTMLAttributes<HTMLOListElement> {
    /**
     * Label for the timeline row
     */
    label: string;
    /**
     * Heading level for the label e.g h2, h3...
     * @default "h3"
     */
    headingTag?: "h2" | "h3" | "h4" | "h5" | "h6";
    /**
     * Icon next to label
     */
    icon?: React.ReactNode;
}
export interface TimelineRowType extends React.ForwardRefExoticComponent<TimelineRowProps & React.RefAttributes<HTMLOListElement>> {
    componentType: TimelineComponentTypes;
}
export declare const TimelineRow: TimelineRowType;
export default TimelineRow;
