import React from "react";
import type { PeriodProps } from "./types.js";
interface TimelineClickablePeriodProps extends PeriodProps {
    onSelectPeriod?: (e: React.MouseEvent<Element, MouseEvent> | React.KeyboardEvent<Element>) => void;
    isActive?: boolean;
    periodRef: React.ForwardedRef<HTMLButtonElement>;
    /**
     * Default orientation of popover
     * @default "top"
     */
    placement?: "top" | "bottom";
}
declare const ClickablePeriod: React.MemoExoticComponent<({ onSelectPeriod, start, end, status, cropped, direction, left, width, icon, children, isActive, statusLabel, restProps, periodRef, }: TimelineClickablePeriodProps) => React.JSX.Element>;
export default ClickablePeriod;
