import React from "react";
import { ToggleGroupProps } from "./ToggleGroup.types.js";
import ToggleItem from "./parts/ToggleItem.js";
interface ToggleGroupComponent extends React.ForwardRefExoticComponent<ToggleGroupProps & React.RefAttributes<HTMLDivElement>> {
    /**
     * @see 🏷️ {@link ToggleItem}
     */
    Item: typeof ToggleItem;
}
/**
 * A component that displays a group of toggle buttons.
 *
 * @see [📝 Documentation](https://aksel.nav.no/komponenter/core/toggle-group)
 * @see 🏷️ {@link ToggleGroupProps}
 *
 * @example
 * ```jsx
 * <ToggleGroup defaultValue="lest" onChange={console.log} size="small">
 *   <ToggleGroup.Item value="ulest" label="Ulest" />
 *   <ToggleGroup.Item value="lest" label="Leste" />
 *   <ToggleGroup.Item value="sendt" label="Sendt" />
 * </ToggleGroup>
 * ```
 */
export declare const ToggleGroup: ToggleGroupComponent;
export default ToggleGroup;
