import React from "react";
type BaseProps = Omit<React.HTMLAttributes<HTMLButtonElement>, "children"> & {
    /**
     * Value for state-handling.
     */
    value: string;
};
type ChildrenProps = {
    /**
     * @deprecated Use `label` and/or `icon` as replacement.
     */
    children: React.ReactNode;
    label?: never;
    icon?: never;
};
type LabelProps = {
    children?: never;
    /**
     * Item label.
     */
    label: React.ReactNode;
    /**
     * Item Icon.
     */
    icon?: React.ReactNode;
};
type IconProps = {
    children?: never;
    /**
     * Item label.
     */
    label?: React.ReactNode;
    /**
     * Item Icon.
     */
    icon: React.ReactNode;
};
export type ToggleGroupItemProps = BaseProps & (ChildrenProps | LabelProps | IconProps);
declare const ToggleItem: React.ForwardRefExoticComponent<ToggleGroupItemProps & React.RefAttributes<HTMLButtonElement>>;
export default ToggleItem;
