import { Locale } from "date-fns/locale";
declare const _default: {
    global: {
        dateLocale: Locale;
        /** @default "Vis mer" */
        showMore: string;
        /** @default "Vis mindre" */
        showLess: string;
        /** @default "Skrivebeskyttet" */
        readOnly: string;
        /** @default "Lukk" */
        close: string;
    };
    Alert: {
        /** @default "Lukk varsel" */
        closeAlert: string;
        /** @default "Lukk melding" */
        closeMessage: string;
        /** @default "Feil" */
        error: string;
        /** @default "Informasjon" */
        info: string;
        /** @default "Suksess" */
        success: string;
        /** @default "Advarsel" */
        warning: string;
    };
    Chips: {
        Removable: {
            /** Will be appended to the accessible name for the button.
            * @default "slett" */
            labelSuffix: string;
        };
    };
    Combobox: {
        /** The input value will be appended to the end of this text, e.g. `Legg til "input value"`.
        * @default "Legg til" */
        addOption: string;
        /** Loader title
        * @default "Søker…" */
        loading: string;
        /** @default "{selected} av maks {limit} er valgt." */
        maxSelected: string;
    };
    CopyButton: {
        /** @default "Kopier" */
        title: string;
        /** @default "Kopiert!" */
        activeText: string;
    };
    DatePicker: {
        /** @default "Velg dato" */
        chooseDate: string;
        /** @default "Velg datoer" */
        chooseDates: string;
        /** @default "Velg start- og sluttdato" */
        chooseDateRange: string;
        /** @default "Velg måned" */
        chooseMonth: string;
        /** @default "Uke" */
        week: string;
        /** @default "Uke {week}" */
        weekNumber: string;
        /** @default "Velg uke {week}" */
        selectWeekNumber: string;
        /** @default "Måned" */
        month: string;
        /** @default "Gå til neste måned" */
        goToNextMonth: string;
        /** @default "Gå til forrige måned" */
        goToPreviousMonth: string;
        /** @default "År" */
        year: string;
        /** @default "Gå til neste år" */
        goToNextYear: string;
        /** @default "Gå til forrige år" */
        goToPreviousYear: string;
        /** @default "Åpne datovelger" */
        openDatePicker: string;
        /** @default "Åpne månedsvelger" */
        openMonthPicker: string;
        /** @default "Lukk datovelger" */
        closeDatePicker: string;
        /** @default "Lukk månedsvelger" */
        closeMonthPicker: string;
    };
    ErrorSummary: {
        /** @default "Du må rette disse feilene før du kan fortsette:" */
        heading: string;
    };
    FileUpload: {
        dropzone: {
            /** @default "Velg fil" */
            button: string;
            /** @default "Velg filer" */
            buttonMultiple: string;
            /** @default "Dra og slipp filen her" */
            dragAndDrop: string;
            /** @default "Dra og slipp filer her" */
            dragAndDropMultiple: string;
            /** @default "Slipp" */
            drop: string;
            /** @default "eller" */
            or: string;
            /** @default "Filopplasting er deaktivert" */
            disabled: string;
            /** @default "Du kan ikke laste opp flere filer" */
            disabledFilelimit: string;
        };
        item: {
            /** @default "Prøv å laste opp filen på nytt" */
            retryButtonTitle: string;
            /** @default "Slett filen" */
            deleteButtonTitle: string;
            /** @default "Laster opp…" */
            uploading: string;
            /** @default "Laster ned…" */
            downloading: string;
        };
    };
    FormProgress: {
        /** @default "Steg {activeStep} av {totalSteps}" */
        step: string;
        /** @default "Vis alle steg" */
        showAllSteps: string;
        /** @default "Skjul alle steg" */
        hideAllSteps: string;
    };
    FormSummary: {
        /** @default "Endre svar" */
        editAnswer: string;
    };
    GuidePanel: {
        /** @default "Illustrasjon av veileder" */
        illustrationLabel: string;
    };
    HelpText: {
        /** @default "Mer informasjon" */
        title: string;
    };
    Loader: {
        /** @default "Venter…" */
        title: string;
    };
    Pagination: {
        /** @default "Forrige" */
        previous: string;
        /** @default "Neste" */
        next: string;
    };
    ProgressBar: {
        /** @default "{current} av {max}" */
        progress: string;
        /** @default "Fremdrift kan ikke beregnes, antatt tid er {seconds} sekunder." */
        progressUnknown: string;
    };
    Search: {
        /** @default "Tøm feltet" */
        clear: string;
        /** @default "Søk" */
        search: string;
    };
    Textarea: {
        /** Screen readers only
        * @default "Tekstområde med plass til {maxLength} tegn." */
        maxLength: string;
        /** @default "{chars} tegn for mye" */
        charsTooMany: string;
        /** @default "{chars} tegn igjen" */
        charsLeft: string;
    };
    Timeline: {
        /** @default "dd.MM.yyyy" */
        dateFormat: string;
        /** @default "dd.MM" */
        dayFormat: string;
        /** @default "MMM yy" */
        monthFormat: string;
        /** @default "yyyy" */
        yearFormat: string;
        Row: {
            /** @default "Ingen perioder" */
            noPeriods: string;
            /** @default "{start} til {end}" */
            period: string;
        };
        Period: {
            /** @default "Suksess" */
            success: string;
            /** @default "Advarsel" */
            warning: string;
            /** @default "Fare" */
            danger: string;
            /** @default "Info" */
            info: string;
            /** @default "Nøytral" */
            neutral: string;
            /** @default "{status} fra {start} til {end}" */
            period: string;
        };
        Pin: {
            /** @default "Pin: {date}" */
            pin: string;
        };
        Zoom: {
            /** @default "Zoom tidslinjen {start} til {end}" */
            zoom: string;
            /** @default "Tilbakestill tidsperspektiv" */
            reset: string;
        };
    };
};
export default _default;
