var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React, { forwardRef } from "react";
import { Slot } from "../../../slot/Slot.js";
import { composeEventHandlers } from "../../composeEventHandlers.js";
import { useMergeRefs } from "../../hooks/index.js";
import { useVirtualFocusDescendant, useVirtualFocusInternalContext, } from "../Context.js";
/**
 * Contains an item you want to be iterable via virtual focus.
 */
export const VirtualFocusItem = forwardRef((_a, ref) => {
    var { children, onActive, onSelect } = _a, rest = __rest(_a, ["children", "onActive", "onSelect"]);
    const { virtualFocusIdx, setVirtualFocusIdx, uniqueId } = useVirtualFocusInternalContext();
    const { register, index } = useVirtualFocusDescendant({
        handleOnActive: () => {
            setVirtualFocusIdx(index);
            onActive();
        },
        handleOnSelect: onSelect,
    });
    const mergedRefs = useMergeRefs(ref, register);
    return (React.createElement(Slot, Object.assign({ ref: mergedRefs }, rest, { id: `virtualfocus-${uniqueId}-${index}`, "data-aksel-virtualfocus": virtualFocusIdx === index, tabIndex: -1, onClick: composeEventHandlers(rest.onClick, () => {
            onSelect();
        }), onMouseMove: composeEventHandlers(rest.onMouseMove, () => {
            setVirtualFocusIdx(index);
            onActive();
        }) }), children));
});
//# sourceMappingURL=VirtualFocusItem.js.map